unit et_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, XIComponents, XIJvControls, XPMan,

  XIInterfaces;

type
  TETForm = class(TForm)
    xiPanel: TxiInterfacePanel;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
  private
    procedure ClickHandler(aRoot: IxiRootNode; aParams: IxiStorage);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ETForm: TETForm;

implementation
uses
 XIEvents,
 XIEventsLib;

{$R *.dfm}

// You can use simple procedures as event handlers...
procedure CheckHow(aRoot: IxiRootNode; aParams: IxiStorage);
var
 l_Choice: Integer;
 l_RootStorage: IxiStorage;
begin
 if Supports(aRoot, IxiStorage, l_RootStorage) then
 begin
  l_Choice := l_RootStorage.GetInteger('how', 0);
  if l_Choice in [2,3] then
  begin
   aRoot.EnableControl('other');
   if l_Choice = 2 then
    l_RootStorage.SetString('other:caption', 'Type your friend''s name here')
    //SetString('name', 'Thomas Smith');
   else
    l_RootStorage.SetString('other:caption', 'Type your "other" details here')
  end
  else
   aRoot.DisableControl('other');
 end;
end;


procedure TETForm.ClickHandler(aRoot: IxiRootNode; aParams: IxiStorage);
var
 l_Index: Integer;
 l_IndexS: string;
 l_RStorage: IxiStorage;
 l_ParamsStr: string;
 l_Sender: string;
begin
 if Supports(xiPanel.XIRoot, IxiStorage, l_RStorage) then
  l_RStorage.SetString('button1:caption', 'Check choice again');

 if Supports(aRoot, IxiStorage, l_RStorage) then
 begin
  l_Index := l_RStorage.GetInteger('how', -1);

  l_Sender := Format('Event fired by: %s'#13#10#13#10,[aParams.GetString('sender', '')]);

  l_ParamsStr := Format('Parameters passed to handler:'#13#10'%s'#13#10'%d'#13#10#13#10,
     [aParams.GetString('param1', ''), aParams.GetInteger('param2', -1)]);
  l_IndexS := IntToStr(l_Index);
  if l_Index = 3 then
   l_IndexS := l_IndexS + #10#13'('+l_RStorage.GetString('other','')+')';

  MessageDlg(l_Sender+l_ParamsStr+'Choice is made!'#10#13'Index: '+l_IndexS, mtInformation, [mbOk], 0);
 end;
 
end;

procedure TETForm.FormCreate(Sender: TObject);
begin
 XIRegisterEventProc('checkhow', CheckHow);
 XIRegisterEventProc('clicketyclick', ClickHandler);
 xiPanel.Construct;
end;

end.
